; Programa: Parte del Package para entorno para agente de juego 
;           sokoban, ver http://e-contento.com/sokoban/
;
; Asignatura: Introduccin a la Inteligencia Artificial
;             ETSII - ULL
; Prctica: 5a (sistemas de produccin)
; Profesor: Patricio Garca (patricio@etsii.ull.es)
; Fecha: 7/6/2005
; Comentarios:
;           Incluye chequeador de soluciones e impresin en HOF
;           Esta parte slo es distribuida en cdigo objeto (.o)
;           ATENCIN:
;           La implementacin autntica de esta parte slo 
;           es distribuida en cdigo objeto (check-sk.o). Este
;           cdigo solo se trata de un sustitutivo para poder
;           trabajar bajo otros lisp y/o versiones de gcl.
;           Para trabajar con l simplemente brrese check-bl.o
;           y entonces sokoban.lsp cargar automticamente ste.
;           Al ejecutarse no computa correctamente el nmero de
;           movimientos tipo push (Push. solucion).
;           Los testeos finales deben realizarse con el autntico
;           check-sk.o, sino no funcionarn.
;


(in-package "sokoban")

; Chequea si una solucin es vlida
;----------------------------------

(defun arefl (mat l)
  (aref mat (first l) (second l)))

(defun sol-val-soko (est)
  " - Funcin: SOL-VAL-SOKO (EST)
     Package:SOKOBAN

Chequea si el estado EST constituye un estado final. EST ha de ser una estructura tipo SOKO."
  (dolist (d (soko-dest est) t)
    (if (not (arefl (soko-mat est) d))
	(return nil))))

; Chekeador de soluciones
; -----------------------

(defun check-soko (sol)
  (values (length sol) (length sol)))


; Imprime en el H.O.F.
; --------------------

(defun gen-tipo (fich)
  "Genera el tipo de problema a insertar en hof, antecede ~ al nombre del fichero si no esta en pathaddhof"
  (format nil "~A"
	  fich))


(defun printhof (&rest ls)
  (print "Opcin :hof no implementada"))
